#ifndef __spatialindex_rbnode_h
#define __spatialindex_rbnode_h

namespace SpatialIndex
{

	class RBTree;
	class RBNode : public Tools::ISerializable
	{
	public:
		RBNode(long, COLOR);
		RBNode(long);
		RBNode(RBTree* tree);
		RBNode(RBTree* tree, long,long, int, byte*);
		~RBNode();


		long getKey() const { return key; }
		void setKey(long key) { this->key = key; }
		COLOR getColor() const { return color; }
		void setColor(COLOR c) { color = c; }
		void showNode();
		virtual unsigned long getByteArraySize();
		virtual unsigned long loadFromByteArray(byte* const data);
		virtual void storeToByteArray(unsigned long& len, byte** data);
		void computeNodeDigest(byte* output);

		//fields also public
	
		RBNode * left;
		RBNode * right;
		RBNode * parent;
		byte* lDigest;
		byte* rDigest;
		byte* cDigest;
		int m_id;
		int m_child;
		int m_leftID;
		int m_rightID;
		long m_pID;
		RBTree* m_tree;

		long key;
		COLOR color;
	};

}
#endif /*__spatialindex_rbnode_h*/
