// Spatial Index Library
//
// Copyright (C) 2002 Navel Ltd.
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Contact information:
//  Mailing address:
//    Marios Hadjieleftheriou
//    University of California, Riverside
//    Department of Computer Science
//    Surge Building, Room 310
//    Riverside, CA 92521
//
//  Email:
//    lifeifei@cs.bu.edu, mhadji@gmail.com

#ifndef __spatialindex_btree_leaf_h
#define __spatialindex_btree_leaf_h

namespace SpatialIndex
{
	namespace BTree
	{
		class Leaf : public Node
		{
		public:
			virtual ~Leaf();

		private:
			Leaf(BTree* pTree, long id);

			virtual NodePtr chooseSubtree(const Point& key, unsigned long level, std::stack<long>& pathBuffer);
			virtual NodePtr findLeaf(const Point& key, long id, std::stack<long>& pathBuffer);
			virtual void deleteData(long id, std::stack<long>& pathBuffer);
			virtual void showNode();

			friend class BTree;
			friend class BulkLoader;
		}; // Leaf
	}
}

#endif /*__spatialindex_btree_leaf_h*/
